'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilityTimeUtilities = require('../utility/TimeUtilities');

var _utilityTimeUtilities2 = _interopRequireDefault(_utilityTimeUtilities);

function isValidAMPM(str) {
  return !!str.match(/^([ap]m)$/ig);
}

var ListBoxItem = (function (_Component) {
  _inherits(ListBoxItem, _Component);

  function ListBoxItem() {
    var _this = this;

    _classCallCheck(this, ListBoxItem);

    _get(Object.getPrototypeOf(ListBoxItem.prototype), 'constructor', this).apply(this, arguments);

    this.onClick = function (event) {
      var _props = _this.props;
      var hours = _props.hours;
      var minutes = _props.minutes;
      var onClick = _props.onClick;

      onClick(event.target, { hours: hours, minutes: minutes });
    };
  }

  _createClass(ListBoxItem, [{
    key: 'render24HourTime',
    value: function render24HourTime() {
      var _props2 = this.props;
      var hours = _props2.hours;
      var minutes = _props2.minutes;

      return _utilityTimeUtilities2['default'].twentyFourHourTimeString({ hours: hours, minutes: minutes });
    }
  }, {
    key: 'render12HourTime',
    value: function render12HourTime() {
      var _props3 = this.props;
      var hours = _props3.hours;
      var minutes = _props3.minutes;

      return _utilityTimeUtilities2['default'].twelveHourTimeString({ hours: hours, minutes: minutes });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props;
      var selected = _props4.selected;
      var hours = _props4.hours;
      var minutes = _props4.minutes;
      var useTwelveHourTime = _props4.useTwelveHourTime;

      var timeString = useTwelveHourTime ? this.render12HourTime() : this.render24HourTime();
      return _react2['default'].createElement(
        'li',
        {
          role: 'option',
          className: selected ? 'selected' : '',
          onClick: this.onClick
        },
        timeString
      );
    }
  }], [{
    key: 'defaultProps',
    value: {
      hours: 0,
      minutes: 0,
      selected: false,
      useTwelveHourTime: false
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      hours: _react.PropTypes.number.isRequired,
      minutes: _react.PropTypes.number.isRequired
    },
    enumerable: true
  }]);

  return ListBoxItem;
})(_react.Component);

var TimeInputListBox = (function (_Component2) {
  _inherits(TimeInputListBox, _Component2);

  _createClass(TimeInputListBox, null, [{
    key: 'defaultProps',
    value: {
      hours: 0,
      minutes: 0,
      useTwelveHourTime: false,
      timeStep: 15
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      hours: _react.PropTypes.number.isRequired,
      minutes: _react.PropTypes.number,
      useTwelveHourTime: _react.PropTypes.bool,
      timeStep: _react.PropTypes.number.isRequired,
      onChange: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }]);

  function TimeInputListBox(props) {
    var _this2 = this;

    _classCallCheck(this, TimeInputListBox);

    _get(Object.getPrototypeOf(TimeInputListBox.prototype), 'constructor', this).call(this, props);
    this.state = {
      hours: this.props.hours,
      minutes: this.props.minutes
    };

    this.onTimeClick = function (target, time) {
      console.log('clicked time: ' + time.hours + ':' + time.minutes);
      _this2.setState(time);
      _this2.props.onChange(time);
    };
  }

  _createClass(TimeInputListBox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ hours: nextProps.hours, minutes: nextProps.minutes });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      _reactDom2['default'].findDOMNode(this.refs.selected).scrollIntoView();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      //ReactDOM.findDOMNode(this.refs.selected).scrollIntoView();
    }
  }, {
    key: 'renderTimeListBoxItems',
    value: function renderTimeListBoxItems() {
      var _this3 = this;

      var _props5 = this.props;
      var timeStep = _props5.timeStep;
      var useTwelveHourTime = _props5.useTwelveHourTime;
      var hours = _props5.hours;
      var minutes = _props5.minutes;

      var timeValues = [];
      for (var loopHours = 0; loopHours < 24; loopHours++) {
        for (var loopMinutes = 0; loopMinutes < 60; loopMinutes += timeStep) {
          var selected = false;
          if (hours === loopHours && minutes === loopMinutes) {
            selected = true;
          }
          timeValues.push({ hours: loopHours, minutes: loopMinutes, selected: selected, useTwelveHourTime: useTwelveHourTime });
        }
      }

      return timeValues.map(function (time) {
        return _react2['default'].createElement(ListBoxItem, _extends({ ref: time.selected ? 'selected' : '', key: time.hours + ':' + time.minutes }, time, { onClick: _this3.onTimeClick }));
      });
    }
  }, {
    key: 'render',
    value: function render() {

      return _react2['default'].createElement(
        'section',
        { className: 'time-input-list-box' },
        _react2['default'].createElement(
          'header',
          null,
          _react2['default'].createElement(
            'h3',
            null,
            'Time Picker'
          )
        ),
        _react2['default'].createElement(
          'ol',
          { role: 'listbox' },
          this.renderTimeListBoxItems()
        )
      );
    }
  }]);

  return TimeInputListBox;
})(_react.Component);

exports['default'] = TimeInputListBox;
module.exports = exports['default'];