'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilityTimeUtilities = require('../utility/TimeUtilities');

var _utilityTimeUtilities2 = _interopRequireDefault(_utilityTimeUtilities);

var _NumberInput = require('./NumberInput');

var _NumberInput2 = _interopRequireDefault(_NumberInput);

function isValidAMPM(str) {
  return !!str.match(/^([ap]m)$/ig);
}

var TimeInputText = (function (_Component) {
  _inherits(TimeInputText, _Component);

  _createClass(TimeInputText, null, [{
    key: 'defaultProps',
    value: {
      hours: 0,
      minutes: 0,
      seconds: 0,
      ampm: 'am',
      useTwelveHourTime: false
    },
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      hours: _react.PropTypes.number.isRequired,
      minutes: _react.PropTypes.number,
      seconds: _react.PropTypes.number,
      ampm: _react.PropTypes.string,
      useTwelveHourTime: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function TimeInputText(props) {
    var _this = this;

    _classCallCheck(this, TimeInputText);

    _get(Object.getPrototypeOf(TimeInputText.prototype), 'constructor', this).call(this, props);
    this.state = {
      hours: this.props.hours,
      minutes: this.props.minutes,
      seconds: this.props.seconds,
      ampm: this.props.ampm,
      useTwelveHourTime: this.props.useTwelveHourTime
    };

    this.onHoursChange = function (hours) {
      console.log('onHoursChange hours ', hours);
      _this.setState({ hours: hours });
    };

    this.onMinutesChange = function (minutes) {
      console.log('onMinutesChange minutes ', minutes);
      _this.setState({ minutes: minutes });
    };

    this.onSecondsChange = function (seconds) {
      console.log('onSecondsChange seconds ', seconds);
      _this.setState({ seconds: seconds });
    };

    this.onAMPMChange = function (event) {
      console.log('onAMPMChange ampm ', event.target.value);
      _this.setState({ ampm: event.target.value });
    };
  }

  _createClass(TimeInputText, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      console.log('TimeInputText componentWillReceiveProps, nextProps ', nextProps);
      this.setState(nextProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state;
      var hours = _state.hours;
      var minutes = _state.minutes;
      var seconds = _state.seconds;
      var ampm = _state.ampm;
      var useTwelveHourTime = _state.useTwelveHourTime;

      var ampmInput;
      if (useTwelveHourTime) {
        ampmInput = _react2['default'].createElement('input', { type: 'text', value: ampm, maxLength: '2', onChange: this.onAMPMChange });
      }

      return _react2['default'].createElement(
        'div',
        { className: 'time-input-text' },
        _react2['default'].createElement(_NumberInput2['default'], { enableZeroFill: true, value: hours, minValue: 0, maxValue: 23, maxLength: 2, onChange: this.onHoursChange }),
        _react2['default'].createElement(
          'span',
          null,
          ':'
        ),
        _react2['default'].createElement(_NumberInput2['default'], { enableZeroFill: true, value: minutes, minValue: 0, maxValue: 59, maxLength: 2, onChange: this.onMinutesChange }),
        _react2['default'].createElement(
          'span',
          null,
          ':'
        ),
        _react2['default'].createElement(_NumberInput2['default'], { enableZeroFill: true, value: seconds, minValue: 0, maxValue: 59, maxLength: 2, onChange: this.onSecondsChange }),
        ampmInput
      );
    }
  }]);

  return TimeInputText;
})(_react.Component);

exports['default'] = TimeInputText;
module.exports = exports['default'];