/*
 *
 *  TimeUtilities.js
 *
 *  2015 December 01
 *  Paul Nichols
 *  paul.rene.nichols@gmail.com
 *
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
function twelveHourTimeString(time) {
  var hours = time.hours;
  var minutes = time.minutes;
  var seconds = time.seconds;

  var adjustedHours = hours < 13 ? hours : hours - 12;
  if (adjustedHours === 0) {
    adjustedHours = 12;
  }
  var ampm = hours < 12 ? 'am' : 'pm';
  var hoursString = adjustedHours < 10 ? '0' + adjustedHours : '' + adjustedHours;
  var minutesString = minutes >= 0 && minutes < 10 ? '0' + minutes : '' + minutes;
  var secondsString = seconds >= 0 && seconds < 10 ? '0' + seconds : '' + seconds;

  var timeString = hoursString;
  if (minutes >= 0) {
    timeString += ':' + minutesString;
  }
  if (seconds >= 0) {
    timeString += ':' + secondsString;
  }

  timeString += ' ' + ampm;

  return timeString;
}

function twentyFourHourTimeString(time) {
  var hours = time.hours;
  var minutes = time.minutes;
  var seconds = time.seconds;

  var hoursString = hours < 10 ? '0' + hours : '' + hours;
  var minutesString = minutes >= 0 && minutes < 10 ? '0' + minutes : '' + minutes;
  var secondsString = seconds >= 0 && seconds < 10 ? '0' + seconds : '' + seconds;

  var timeString = hoursString;
  if (minutes >= 0) {
    timeString += ':' + minutesString;
  }
  if (seconds >= 0) {
    timeString += ':' + secondsString;
  }

  return timeString;
}

var TimeUtilities = {
  twelveHourTimeString: twelveHourTimeString,
  twentyFourHourTimeString: twentyFourHourTimeString
};

window.TimeUtilities = TimeUtilities;

exports['default'] = TimeUtilities;
module.exports = exports['default'];